// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_1.x.x_GSC_DN/samples/sbtest/set_rx_clock_source.c $
// $Rev: 53081 $
// $Date: 2023-06-13 10:10:10 -0500 (Tue, 13 Jun 2023) $

// SIO4: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	service_data_t	list[]	=
	{
		// service			cmd							arg				reg				mask	value
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	CLOCK_DISABLED,	SIO4_USC_CMCR,	0x7,	0x0	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	RXC_PIN_CLOCK,	SIO4_USC_CMCR,	0x7,	0x1	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	TXC_PIN_CLOCK,	SIO4_USC_CMCR,	0x7,	0x2	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	DPLL_CLOCK,		SIO4_USC_CMCR,	0x7,	0x3	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	BRG0_CLOCK,		SIO4_USC_CMCR,	0x7,	0x4	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	BRG1_CLOCK,		SIO4_USC_CMCR,	0x7,	0x5	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	CTR0_CLOCK,		SIO4_USC_CMCR,	0x7,	0x6	},
		{ SERVICE_BY_VAL,	SIO4_SET_RX_CLOCK_SOURCE,	CTR1_CLOCK,		SIO4_USC_CMCR,	0x7,	0x7	},
		{ SERVICE_END_LIST }
	};

	int	errs	= 0;

	errs	+= sio4_reset_channel(fd, 0);
	errs	+= service_ioctl_set_reg_list(fd, list);
	errs	+= service_ioctl_set_reg_list(fd, list);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



//*****************************************************************************
int set_rx_clock_source_tests(int fd, const data_t* data)
{
	int	errs	= 0;

	gsc_label("SIO4_SET_RX_CLOCK_SOURCE");

	if (data->fw_type == SIO4_FW_TYPE_CONFIG_Z16C30)
	{
		errs	+= _service_test(fd);
		errs	+= _function_test(fd);

		if (errs == 0)
			printf("PASS\n");
	}
	else
	{
		printf("SKIPPED  (Not supported.)\n");
	}

	errs	= errs ? 1 : 0;
	return(errs);
}


