// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_1.x.x_GSC_DN/utils/util_channel.c $
// $Rev: 53094 $
// $Date: 2023-06-13 10:21:23 -0500 (Tue, 13 Jun 2023) $

// SIO4: Utilities: source file

#include "main.h"

// Useless code for the validation script.
//	if (verbose
//	if (verbose



/******************************************************************************
*
*	Function:	channel_command_send
*
*	Purpose:
*
*		Put a wrapper around the sio4_channel_command_send() call.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		cmd		The command to send.
*
*		loud	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int channel_command_send(int fd, SIO4_CHAN_CMD cmd, int loud)
{
	int	errs;
	int	ret;

	ret		= sio4_channel_command_send(fd, cmd, 0);
	errs	= (ret < 0) ? 1 : 0;
	gsc_label_fail_func(errs, loud, "sio4_channel_command_send");
	return(errs);
}



/******************************************************************************
*
*	Function:	channel_init
*
*	Purpose:
*
*		Put a wrapper around the sio4_channel_init() call.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		loud	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int channel_init(int fd, int loud)
{
	int	errs;
	int	ret;

	ret		= sio4_channel_init(fd, 0);
	errs	= (ret < 0) ? 1 : 0;
	gsc_label_fail_func(errs, loud, "sio4_channel_init");
	return(errs);
}



/******************************************************************************
*
*	Function:	channel_reset
*
*	Purpose:
*
*		Put a wrapper around the sio4_channel_reset() call.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		loud	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int channel_reset(int fd, int loud)
{
	int	errs;
	int	ret;

	ret		= sio4_channel_reset(fd, 0);
	errs	= (ret < 0) ? 1 : 0;
	gsc_label_fail_func(errs, loud, "sio4_channel_reset");
	return(errs);
}



